<template>
  <BasicLayout>
    <template #wrapper>
      <el-card class="box-card">
        <el-form ref="queryForm" :model="queryParams" :inline="true" label-width="68px">
          <el-form-item label="翻译平台">
            <el-select v-model="queryParams.platformId" placeholder="请选择翻译平台" clearable>
              <el-option
                v-for="item in tmPlatformList"
                :key="item.id"
                :label="item.name"
                :value="item.id"
              />
            </el-select>
          </el-form-item>
          <el-form-item>
            <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
            <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
          </el-form-item>
        </el-form>

        <el-row :gutter="10" class="mb8">
          <el-col :span="1.5">
            <el-button
              v-permisaction="['admin:tmPlatformAccount:add']"
              type="primary"
              icon="el-icon-plus"
              size="mini"
              @click="handleAdd"
            >新增
            </el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button
              v-permisaction="['admin:tmPlatformAccount:edit']"
              type="success"
              icon="el-icon-edit"
              size="mini"
              :disabled="single"
              @click="handleUpdate"
            >修改
            </el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button
              v-permisaction="['admin:tmPlatformAccount:remove']"
              type="danger"
              icon="el-icon-delete"
              size="mini"
              :disabled="multiple"
              @click="handleDelete"
            >删除
            </el-button>
          </el-col>
        </el-row>

        <el-table v-loading="loading" :data="tmPlatformAccountList" @selection-change="handleSelectionChange">
          <el-table-column type="selection" width="55" align="center" />
          <el-table-column label="平台" align="center" prop="platformId" :show-overflow-tooltip="true">
            <template slot-scope="scope">
              {{ platformFormat(scope.row.platformId) }}
            </template>
          </el-table-column>
          <el-table-column
            label="api_key"
            align="center"
            prop="apiKey"
            :show-overflow-tooltip="true"
          /><el-table-column
            label="api密钥"
            align="center"
            prop="apiSecret"
            :show-overflow-tooltip="true"
          />
          <el-table-column label="剩余字符" align="center" prop="remainChars" :show-overflow-tooltip="true" />

          <el-table-column label="状态" align="center" width="80px">
            <template slot-scope="scope">
              <el-tag v-if="scope.row.status === 1" type="success">启用</el-tag>
              <el-tag v-else type="danger">禁用</el-tag>
            </template>
          </el-table-column>
          <!-- <el-table-column
            label="qps限制"
            align="center"
            prop="qpsLimit"
            :show-overflow-tooltip="true"
          /> -->
          <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
            <template slot-scope="scope">
              <el-popconfirm
                class="delete-popconfirm"
                title="确认要修改吗?"
                confirm-button-text="修改"
                @confirm="handleUpdate(scope.row)"
              >
                <el-button
                  slot="reference"
                  v-permisaction="['admin:tmPlatformAccount:edit']"
                  size="mini"
                  type="text"
                  icon="el-icon-edit"
                >修改
                </el-button>
              </el-popconfirm>
              <el-popconfirm
                class="delete-popconfirm"
                title="确认要删除吗?"
                confirm-button-text="删除"
                @confirm="handleDelete(scope.row)"
              >
                <el-button
                  slot="reference"
                  v-permisaction="['admin:tmPlatformAccount:remove']"
                  size="mini"
                  type="text"
                  icon="el-icon-delete"
                >删除
                </el-button>
              </el-popconfirm>
              <el-popconfirm
                class="delete-popconfirm"
                title="确定要查询剩余字符吗?"
                confirm-button-text="查询"
                @confirm="handleQueryRemainChars(scope.row)"
              >
                <el-button
                  slot="reference"
                  v-permisaction="['admin:tmPlatformAccount:query']"
                  size="mini"
                  type="text"
                  icon="el-icon-s-data"
                >查询
                </el-button>
              </el-popconfirm>
            </template>
          </el-table-column>
        </el-table>

        <pagination
          v-show="total > 0"
          :total="total"
          :page.sync="queryParams.pageIndex"
          :limit.sync="queryParams.pageSize"
          @pagination="getList"
        />

        <!-- 添加或修改对话框 -->
        <el-dialog :title="title" :visible.sync="open" width="500px" :close-on-click-modal="false">
          <el-form ref="form" :model="form" :rules="rules" label-width="80px">
            <el-form-item label="翻译平台" prop="platformId">
              <el-select v-model="form.platformId" placeholder="请选择翻译平台" clearable :disabled="isEdit">
                <el-option
                  v-for="(item, index) in tmPlatformList"
                  :key="'form-platformId-' + index"
                  :value="item.id"
                  :label="item.name"
                />
              </el-select>
            </el-form-item>
            <el-form-item label="api_key" prop="apiKey">
              <el-input
                v-model="form.apiKey"
                placeholder="api_key"
                show-word-limit
                maxlength="500"
              />
            </el-form-item>
            <el-form-item label="api密钥" prop="apiSecret">
              <el-input
                v-model="form.apiSecret"
                placeholder="api密钥"
                show-word-limit
                maxlength="255"
              />
            </el-form-item>
            <el-form-item label="qps限制" prop="qpsLimit">
              <el-input v-model.number="form.qpsLimit" placeholder="qps限制" />
            </el-form-item>
          </el-form>
          <div slot="footer" class="dialog-footer">
            <el-button type="primary" :loading="loading" @click="submitForm">确 定</el-button>
            <el-button @click="cancel">取 消</el-button>
          </div>
        </el-dialog>
      </el-card>
    </template>
  </BasicLayout>
</template>

<script>
import { addTmPlatformAccount, delTmPlatformAccount, getTmPlatformAccount, listTmPlatformAccount, updateTmPlatformAccount, tmPlatformAccountRemain } from '@/api/admin/tm-platform-account'
import { listTmPlatform } from '@/api/admin/tm-platform'

export default {
  name: 'TmPlatformAccount',
  components: {
  },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 总条数
      total: 0,
      // 弹出层标题
      title: '',
      // 是否显示弹出层
      open: false,
      isEdit: false,
      // 类型数据字典
      typeOptions: [],
      tmPlatformAccountList: [],
      tmPlatformList: [],
      // 关系表类型

      // 查询参数
      queryParams: {
        pageIndex: 1,
        pageSize: 10,
        platformId: undefined

      },
      // 表单参数
      form: {
      },
      // 表单校验
      rules: {
        platformId: [{ required: true, message: '请选择翻译平台', trigger: 'blur' }],
        apiKey: [{ required: true, message: '请输入api_key', trigger: 'blur' }]

      }
    }
  },
  created() {
    this.getList()
    this.getPlatformList()
  },
  methods: {
    /** 查询参数列表 */
    getList() {
      this.loading = true
      listTmPlatformAccount(this.addDateRange(this.queryParams, this.dateRange)).then(response => {
        this.tmPlatformAccountList = response.data.list
        this.total = response.data.count
        this.loading = false
      }
      )
    },
    platformFormat(platformId) {
      const platform = this.tmPlatformList.find(item => item.id === platformId)
      return platform ? platform.name : ''
    },
    getPlatformList() {
      listTmPlatform({ pageIndex: 1, pageSize: 1000 }).then(response => {
        this.tmPlatformList = response.data.list
      }
      )
    },
    // 取消按钮
    cancel() {
      this.open = false
      this.reset()
    },
    // 表单重置
    reset() {
      this.form = {

        id: undefined,
        platformId: undefined,
        apiKey: undefined,
        apiSecret: undefined,
        qpsLimit: undefined
      }
      this.resetForm('form')
    },
    getImgList: function() {
      this.form[this.fileIndex] = this.$refs['fileChoose'].resultList[0].fullUrl
    },
    fileClose: function() {
      this.fileOpen = false
    },
    // 关系
    // 文件
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageIndex = 1
      this.getList()
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.dateRange = []
      this.resetForm('queryForm')
      this.handleQuery()
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset()
      this.open = true
      this.title = '添加翻译管理_平台账号'
      this.isEdit = false
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length !== 1
      this.multiple = !selection.length
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset()
      const id =
                row.id || this.ids
      getTmPlatformAccount(id).then(response => {
        this.form = response.data
        this.open = true
        this.title = '修改翻译管理_平台账号'
        this.isEdit = true
      })
    },
    /** 提交按钮 */
    submitForm: function() {
      this.$refs['form'].validate(valid => {
        if (valid) {
          if (this.form.id !== undefined) {
            updateTmPlatformAccount(this.form).then(response => {
              if (response.code === 200) {
                this.msgSuccess(response.msg)
                this.open = false
                this.getList()
              } else {
                this.msgError(response.msg)
              }
            })
          } else {
            addTmPlatformAccount(this.form).then(response => {
              if (response.code === 200) {
                this.msgSuccess(response.msg)
                this.open = false
                this.getList()
              } else {
                this.msgError(response.msg)
              }
            })
          }
        }
      })
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      var Ids = (row.id && [row.id]) || this.ids

      this.$confirm('是否确认删除编号为"' + Ids + '"的数据项?', '警告', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(function() {
        return delTmPlatformAccount({ 'ids': Ids })
      }).then((response) => {
        if (response.code === 200) {
          this.msgSuccess(response.msg)
          this.open = false
          this.getList()
        } else {
          this.msgError(response.msg)
        }
      }).catch(function() {
      })
    },
    /**
     * 查询字符余额
     *  */
    handleQueryRemainChars(row) {
      this.loading = true

      tmPlatformAccountRemain(row.id).then(response => {
        if (response.code === 200) {
          this.msgSuccess(response.msg)
          this.getList()
        } else {
          this.msgError(response.msg)
        }
      })
        .finally(() => {
          this.loading = false
        })
    }
  }
}
</script>
